#include "ClassPad.h"
#include <stdio.h>
//////////////////////////////////////////////////////////////////


#define DW_NEW 2001
#define DW_SOL 2002

#define DW_1 2003
#define DW_2 2004
#define DW_3 2005




class TT:public PegWindow     
{
    public:
    virtual SIGNED  Message (const PegMessage &Mesg);
    virtual SIGNED Execute();
    //virtual void  OnPointerMove (const PegPoint &p);
    int x,y,vx,vy,xp,vxp;
    TT(PegRect rec):PegWindow(rec,FF_THIN)
    {
        x=0;
        y=0;
        vx=2;
        vy=1;
        xp=0;
        vxp=0;
    };    
};




        

SIGNED  TT::Message (const PegMessage &Mesg)
{
 
       switch(Mesg.wType)
       {
             case PM_KEY:
                 if (Mesg.iData==0x0260)
                    vxp=-2;
                 if (Mesg.iData==0x0261)
                    vxp=2;                    
                 break;
             case PM_KEY_RELEASE:
                    vxp=0;                    
                 break;

        default:
                return PegWindow::Message(Mesg);
       }
       return 0;
}
   


SIGNED TT::Execute()
{
   PegMessage pSend; 
   while(1) { 

   x+=vx;
   y+=vy;
   xp+=vxp;
   if (x<0)
   {
    x=0;
    vx=-vx;   
   }    
   if (y<0)
   {
    y=0;
    vy=-vy;   
   }    
   if (x>159-10)
   {
       x=159-10;
       vx=-vx;
   }    
   if (y>200-10)
   {
       
       if ((x>xp+40)||(x+10<xp))
       {
           PegMessageWindow *pWin = new PegMessageWindow("Ah le nul","la loose!!!", MW_OK);
            pWin->Execute();

          break;
      }    
       y=200-10;
       vy=-vy;
   }    
   
  Invalidate();     
  BeginDraw();
    DrawFrame();
    DrawChildren();

    PegRect rect={x,y,x+10,y+10};
    Rectangle(rect,BLACK,10);

    rect.Set(xp,200,xp+40,205);
    Rectangle(rect,BLACK);
    
  EndDraw();    
  #ifdef WIN32
       Bevt_Wait(1);
  #endif
       
      // pop message from the queue and dispatch 
      if (MessageQueue()->PopNoIdle(&pSend)) 
      { 
         int iReturn = Presentation()->DispatchMessage(Presentation(), &pSend); 
         if (iReturn) return iReturn; 
      } 

      // now do a message pump without waiting 
#ifdef WIN32 
      MSG msg; 
      if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) && (msg.message != WM_QUIT)) 
      { 
         DispatchMessage(&msg); 
      } 
#else 
      if (GetSystemMessage(&pSend,IM_RCVTMO_POL))
      { 
         // NOTE: There is a  problem where CLEAR can get lost when starting the app, 
         // so force it to 'this' 
         if (pSend.wType==HM_SYS_CLEAR) pSend.pTarget = this;
         
         if (pSend.wType==HM_SYS_CLOSE)
         {
            MessageQueue()->Push(pSend); 
              break; 
         }    
         MessageQueue()->Push(pSend); 
      } 
#endif 
       }        
    return 0;
    
}    



void PegAppInitialize(PegPresentationManager *pPresentation)
{
	// create some simple Windows: 
	PegRect Rect;
	Rect.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM-STATUS_HEIGHT);

    TT *mw=new TT(Rect);
	
  pPresentation->Add(mw);
  mw->Execute();

};


//////////////////////////////////////////////////////////////////

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
	return "";
}

//////////////////////////////////////////////////////////////////
